<?php
/**
 * Miranda IM Sendlog   2.0.3.20030701   (major.minor.build.yyyymmdd)
 * Copyright (c) 2003 by Michal Nazarewicz (mina86@tlen.pl)
 * Based on sendlog in php 0.0.2.1 by HuzursuZ
 */

/**
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * NOTE: Sorry for my poor English, it's not my native language..
 */

/**
 * CHANGELOG
 *   2.0.3.20030701
 *     + added partial protocol support (support sending messages, notices and
 *         error messages)
 *     * everything has been rewritten
 *     - not-OOP version removed
 *     - documentation in source file has been removed (it was difficult to
 *         read source file)
 *   1.1.2.20030519:
 *     + added not-OOP version of script
 *   1.0.1.20030518:
 *     * first version
 */

if (!defined('INC_MIM_SENDLOG')) {
define('INC_MIM_SENDLOG', true);

class mim_sendlog {
	function get_error() {
		return $this -> error;
	}


	function mim_sendlog($host = '127.0.0.1', $port = 12001, $timeout = 30) {
		$this -> set_connection_options($host, $port, $timeout);
	}


	function send_message(/* ... */) {
		$argc = func_num_args();
		$argv = func_get_args();

		// Check arguments
		switch ($argc) {
			case 0:
				return $this -> error("Not enought parameters");
			case 1:
				$title = null;
				$msg = $argv[0];
				break;
			case 2:
				$title = $argv[0];
				$msg = $argv[1];
				break;
			default:
				return $this -> error("Too many parameters");
		}

		// Security
		if (strpos($title, '#')!==false || strpos($msg, '#'))
			return $this -> error("Message and title cannot contain '#'");

		// Create message to send
		$message = '%';
		if ($title!==null)
			$message .= "$title#";
		$message .= $msg;

		// Send
		return $this -> send($message);
	}


	function send_notice(/* ... */) {
		$argc = func_num_args();
		$argv = func_get_args();

		// Check arguments
		switch ($argc) {
			case 0:
				return $this -> error("Not enought parameters");
			case 1:
				$title = null;
				$msg = $argv[0];
				break;
			case 2:
				$title = $argv[0];
				$msg = $argv[1];
				break;
			default:
				return $this -> error("Too many parameters");
		}

		// Security
		if (($title!=null && strpos($title, '#')!==false) || strpos($msg, '#'))
			return $this -> error("Message and title cannot contain '#'");

		// Create message to send
		$message = '';
		if ($title!==null)
			$message .= "$title#";
		$message .= $msg;

		// Send
		return $this -> send($message);
	}


	function send_error(/* ... */) {
		$argc = func_num_args();
		$argv = func_get_args();

		// Check arguments
		switch ($argc) {
			case 0:
				return $this -> error("Not enought parameters");
			case 1:
				$title = null;
				$msg = $argv[0];
				break;
			case 2:
				$title = $argv[0];
				$msg = $argv[1];
				break;
			default:
				return $this -> error("Too many parameters");
		}

		// Security
		if (strpos($title, '#')!==false || strpos($msg, '#'))
			return $this -> error("Message and title cannot contain '#'");

		// Create message to send
		$message = '!';
		if ($title!==null)
			$message .= "$title#";
		$message .= $msg;

		// Send
		return $this -> send($message);
	}


	function set_connection_options($host = null, $port = null,
			$timeout = null) {
		if ($host!==null)
			$this -> host = $host;
		if ($port!==null)
			$this -> port = $port;
		if ($timeout!==null)
			$this -> timeout = $timeout;
	}


	function get_host() {
		return $this -> host . ':' . $this -> port;
	}


	function get_timeout() {
		return $this -> timeout;
	}


	/*** PRIVATE or PROTECTED data ***/
	/* DO USE THEM OUTSIDE OF CLASS */
	function send($message) {
		// Clear error message
		$this -> error = '';

		// Try to connect
		$fp = @fsockopen("udp://" . $this -> host, $this -> port, $errno, $errstr,
			$this -> timeout);
		if (!$fp)
			return $this -> error("Could not connect to (#$errno: $errstr)");

		// Try to write
		$result = @fwrite($fp, $message);

		// Close socket
		@fclose($fp);

		// Check if eveything went OK
		if ($result)
			return true;
		else
			return $this -> error('Error while sending message.');
	}


	var $host = '127.0.0.1';
	var $port = 12001;
	var $timeout = 30;
	var $error = '';

	function error($error, $ret = false) {
		$this -> error = $error;
		return $ret;
	}
}

} // if (defined())
?>